DefInt A-Z

'Windows Definitions *************************************
  'Logical Palette
    Type LogPalette256Lng
      Version As Integer
      NumEntries As Integer
      'PalEntry(0 To 255) As Long
      PalEntry(0 To 275) As Long
    End Type

  'Rectangle structure used by FillRect
    Type RectType
      Left As Integer
      Top As Integer
      Right As Integer
      Bottom As Integer
    End Type
    
  'Custom (aliased, type-safe) palette creation function
    Declare Function CreatePal256Lng% Lib "GDI" Alias "CreatePalette" (lpLogPalette As LogPalette256Lng)

  'Unaltered API Declarations
    Declare Function CloseClipboard% Lib "User" ()
    Declare Function CreatePen% Lib "GDI" (ByVal nPenStyle%, ByVal nWidth%, ByVal crColor&)
    Declare Function CreateSolidBrush% Lib "GDI" (ByVal crColor&)
    Declare Function DeleteObject% Lib "GDI" (ByVal hObject%)
    Declare Function FillRect Lib "User" (ByVal hDC As Integer, lpRect As RectType, ByVal hBrush As Integer) As Integer
    Declare Function GetPaletteEntries% Lib "GDI" (ByVal hPalette%, ByVal wStartIndex%, ByVal wNumEntries%, lpPaletteEntries As Long)
    Declare Function GetPixel& Lib "GDI" (ByVal hDC%, ByVal x%, ByVal y%)
    Declare Function GetSystemPaletteEntries% Lib "GDI" (ByVal hDC%, ByVal wStartIndex%, ByVal wNumEntries%, lpPaletteEntries As Long)
    Declare Function OpenClipboard% Lib "User" (ByVal hWnd%)
    Declare Function Rectangle% Lib "GDI" (ByVal hDC%, ByVal X1%, ByVal Y1%, ByVal X2%, ByVal Y2%)
    Declare Function SelectObject% Lib "GDI" (ByVal hDC%, ByVal hObject%)
    Declare Function SendMessageByNum& Lib "User" Alias "SendMessage" (ByVal hWnd%, ByVal wMsg%, ByVal wParam%, ByVal lParam&)
    Declare Function SetClipboardData% Lib "User" (ByVal wFormat%, ByVal hMem%)

  'Palette entry flags
    Global Const PC_RESERVED = &H1
    Global Const PC_EXPLICIT = &H2
    Global Const PC_NOCOLLAPSE = &H4
  
  'Brush Styles
    Global Const BS_SOLID = 0
    Global Const BS_NULL = 1
    Global Const BS_HOLLOW = BS_NULL
    Global Const BS_HATCHED = 2
    Global Const BS_PATTERN = 3
    Global Const BS_INDEXED = 4
    Global Const BS_DIBPATTERN = 5
    
  'Hatch Styles
    Global Const HS_HORIZONTAL = 0  '  -----
    Global Const HS_VERTICAL = 1    '  |||||
    Global Const HS_FDIAGONAL = 2   '  \\\\\
    Global Const HS_BDIAGONAL = 3   '  /////
    Global Const HS_CROSS = 4       '  +++++
    Global Const HS_DIAGCROSS = 5   '  xxxxx
    
  'Pen Styles
    Global Const PS_SOLID = 0
    Global Const PS_DASH = 1        '  -------
    Global Const PS_DOT = 2         '  .......
    Global Const PS_DASHDOT = 3     '  _._._._
    Global Const PS_DASHDOTDOT = 4  '  _.._.._
    Global Const PS_NULL = 5
    Global Const PS_INSIDEFRAME = 6
  

'Visual Basic Constants **********************************
  ' This is a message used within Visual Basic to retrieve
  ' the handle of a palette
    Global Const VBM_GETPALETTE% = &H101C
  
  'Clipboard formats
    Global Const CF_LINK = &HBF00
    Global Const CF_TEXT = 1
    Global Const CF_BITMAP = 2
    Global Const CF_METAFILE = 3
    Global Const CF_DIB = 8
    Global Const CF_PALETTE = 9
    
  ' DrawMode
    Global Const BLACKNESS = 1      ' 1 - Blackness
    Global Const NOT_MERGE_PEN = 2  ' 2 - Not Merge Pen
    Global Const MASK_NOT_PEN = 3   ' 3 - Mask Not Pen
    Global Const NOT_COPY_PEN = 4   ' 4 - Not Copy Pen
    Global Const MASK_PEN_NOT = 5   ' 5 - Mask Pen Not
    Global Const INVERT = 6         ' 6 - Invert
    Global Const XOR_PEN = 7        ' 7 - Xor Pen
    Global Const NOT_MASK_PEN = 8   ' 8 - Not Mask Pen
    Global Const MASK_PEN = 9       ' 9 - Mask Pen
    Global Const NOT_XOR_PEN = 10   ' 10 - Not Xor Pen
    Global Const NOP = 11           ' 11 - Nop
    Global Const MERGE_NOT_PEN = 12 ' 12 - Merge Not Pen
    Global Const COPY_PEN = 13      ' 13 - Copy Pen
    Global Const MERGE_PEN_NOT = 14 ' 14 - Merge Pen Not
    Global Const MERGE_PEN = 15     ' 15 - Merge Pen
    Global Const WHITENESS = 16     ' 16 - Whiteness
    
  ' DrawStyle
    Global Const SOLID = 0        ' 0 - Solid
    Global Const DASH = 1         ' 1 - Dash
    Global Const DOT = 2          ' 2 - Dot
    Global Const DASH_DOT = 3     ' 3 - Dash-Dot
    Global Const DASH_DOT_DOT = 4 ' 4 - Dash-Dot-Dot
    Global Const INVISIBLE = 5    ' 5 - Invisible
    Global Const INSIDE_SOLID = 6 ' 6 - Inside Solid
  
  ' FillStyle
    ' Global Const SOLID = 0           ' 0 - Solid
    Global Const TRANSPARENT = 1       ' 1 - Transparent
    Global Const HORIZONTAL_LINE = 2   ' 2 - Horizontal Line
    Global Const VERTICAL_LINE = 3     ' 3 - Vertical Line
    Global Const UPWARD_DIAGONAL = 4   ' 4 - Upward Diagonal
    Global Const DOWNWARD_DIAGONAL = 5 ' 5 - Downward Diagonal
    Global Const CROSS = 6             ' 6 - Cross
    Global Const DIAGONAL_CROSS = 7    ' 7 - Diagonal Cross
  
  
  

